<script setup>
import { useRenderLoop, useTexture, useTres } from '@tresjs/core';
import { Sphere } from '@tresjs/cientos';
import { shallowRef, watchEffect, watch } from 'vue';
import { OrbitControls } from 'three/addons/controls/OrbitControls.js';
import { usePlanetStore } from '@/stores/planet';
import { storeToRefs } from 'pinia';

const planetStore = usePlanetStore();

const { selectedPlanetName } = storeToRefs(planetStore);

const { state } = useTres();
const sceneCamera = shallowRef();

// Defining planet
const planetRef = shallowRef();

// Defining textures
let texture = await useTexture([`./textures/2k_${planetStore.selectedPlanetName}.jpg`]);

watch(selectedPlanetName, async () => {
  let texture2 = await useTexture([`./textures/2k_${planetStore.selectedPlanetName}.jpg`]);
  planetRef.value.value.material.map = texture2;
  texture.dispose();
});

function animatePlanet() {
  if (!sceneCamera.value) return;
  if (!planetRef.value) return;
  planetRef.value.value.rotateY(0.004);
}

let controls = null;

const { onLoop } = useRenderLoop();

onLoop(() => {
  animatePlanet();
  controls.update();
});

watchEffect(() => {
  if (state.renderer && state.camera) {
    controls = new OrbitControls(state.camera, state.renderer.domElement);
    controls.enableDamping = true;
    controls.enablePan = false;
    controls.enableZoom = false;
  }
});

window.addEventListener('resize', onWindowResize, false);

function onWindowResize() {
  state.camera.aspect = window.innerWidth / window.innerHeight;
  state.camera.updateProjectionMatrix();
  state.renderer.setSize(window.innerWidth, window.innerHeight);
}
</script>

<template>
  <TresCanvas window-size>
    <TresPerspectiveCamera
      ref="sceneCamera"
      :args="[75, 1, 0.1, 1000]"
      :position="[-10, 10, -20]"
      :lookat="[0, 0, 0]"
    />
    <TresScene>
      <TresMesh ref="planetOrbit">
        <Sphere ref="planetRef" :args="[10]" :position="[0, 0, 0]" name="planet">
          <TresMeshBasicMaterial :map="texture" />
        </Sphere>
      </TresMesh>
    </TresScene>
    <TresAxesHelper />
  </TresCanvas>
</template>
<style scoped>
.lightspeed {
}
</style>
